fuzzydl

## Class OwaConcept

- java.lang.Object
- - fuzzydl.Concept
  - - fuzzydl.OwaConcept

- Direct Known Subclasses:
    QowaConcept

      public class OwaConcept
      extends Concept

  OWA concept.
  Author:
    Fernando Bobillo

- - ### Field Summary

    - ### Fields inherited from class fuzzydl.Concept

      `ALL, AND, AT_LEAST_VALUE, AT_MOST_VALUE, ATOMIC, BOTTOM, CHOQUET_INTEGRAL, COMPLEMENT, CONCEPT_BOTTOM, CONCEPT_TOP, CONCRETE, CONCRETE_COMPLEMENT, DEFAULT_NAME, EXACT_VALUE, EXT_NEG_THRESHOLD, EXT_POS_THRESHOLD, FUZZY_NUMBER, FUZZY_NUMBER_COMPLEMENT, G_AND, G_IMPLIES, G_OR, HAS_VALUE, L_AND, L_OR, LOOSE_LOWER_APPROX, LOOSE_UPPER_APPROX, LOWER_APPROX, MODIFIED, MODIFIED_COMPLEMENT, NEG_THRESHOLD, NOT_AT_LEAST_VALUE, NOT_AT_MOST_VALUE, NOT_CHOQUET_INTEGRAL, NOT_EXACT_VALUE, NOT_EXT_NEG_THRESHOLD, NOT_EXT_POS_THRESHOLD, NOT_G_IMPLIES, NOT_HAS_VALUE, NOT_NEG_THRESHOLD, NOT_OWA, NOT_POS_THRESHOLD, NOT_QUANTIFIED_OWA, NOT_QUASI_SUGENO_INTEGRAL, NOT_SELF, NOT_SUGENO_INTEGRAL, NOT_W_MAX, NOT_W_MIN, NOT_W_SUM, NOT_W_SUM_ZERO, NOT_WEIGHTED, NOT_Z_IMPLIES, OR, OWA, POS_THRESHOLD, QUANTIFIED_OWA, QUASI_SUGENO_INTEGRAL, SELF, SOME, SUGENO_INTEGRAL, TIGHT_LOWER_APPROX, TIGHT_UPPER_APPROX, TOP, UPPER_APPROX, W_MAX, W_MIN, W_SUM, W_SUM_ZERO, WEIGHTED, Z_IMPLIES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OwaConcept(java.util.ArrayList<java.lang.Double> weights, java.util.ArrayList<Concept> concepts)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Concept` | `complement()` Gets the complement of the concept.
    `java.util.HashSet<Concept>` | `computeAtomicConcepts()` Gets a set of the atomic concepts that compose the current concept.
    `java.util.HashSet<java.lang.String>` | `getRoles()` Gets a set of the roles that compose the current concept.
    `Concept` | `replace(Concept a, Concept c)` Gets a new concept by replacing an atomic concept a with a complex concept c.
    `void` | `solveAssertion(Individual ind, KnowledgeBase kb)` Solves an assertion of the form (individual, concept) with respect to a fuzzy KB.
    `void` | `solveComplementedAssertion(Individual ind, KnowledgeBase kb)` Solves an assertion of the form (individual, not concept) with respect to a fuzzy KB.
    `java.lang.String` | `toString()` Gets a printable name of the concept.

    - ### Methods inherited from class fuzzydl.Concept

      `all, and, and, atLeastValue, atMostValue, complement, containsNegatedSubconcept, containsSubconcept, equals, exactValue, extendedNegThreshold, extendedPosThreshold, gAnd, gAnd, getAtomicConceptNames, getAtomicConcepts, getRole, getType, getValue, getWeight, getWeightVar, gImplies, gOr, gOr, hasNominals, hasValue, hasValue, isAtomic, isComplementedAtomic, isConcrete, kdImplies, lAnd, lAnd, lImplies, looseLowerApprox, looseUpperApprox, lOr, lOr, lowerApprox, nAry, negThreshold, newAtomicConcept, notHasValue, or, or, posThreshold, removeElement, self, setName, setType, setValue, some, tightLowerApprox, tightUpperApprox, upperApprox, weightedConcept, zImplies`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### OwaConcept

          public OwaConcept(java.util.ArrayList<java.lang.Double> weights,
                            java.util.ArrayList<Concept> concepts)
                     throws FuzzyOntologyException

      Throws:
        `FuzzyOntologyException`

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Description copied from class: `Concept`
      Gets a printable name of the concept.
      Overrides:
        `toString` in class `Concept`
      Returns:
        Name of the concept.

    - #### complement

          public Concept complement()
                             throws FuzzyOntologyException

      Gets the complement of the concept.
      Returns:
        Complement of the concept.
      Throws:
        `FuzzyOntologyException` - fuzzy ontology exception.

    - #### solveAssertion

          public void solveAssertion(Individual ind,
                                     KnowledgeBase kb)

      Solves an assertion of the form (individual, concept) with respect to a fuzzy KB.
      Parameters:
        `ind` - An individual.
        `kb` - A fuzzy KB.

    - #### solveComplementedAssertion

          public void solveComplementedAssertion(Individual ind,
                                                 KnowledgeBase kb)

      Solves an assertion of the form (individual, not concept) with respect to a fuzzy KB.
      Parameters:
        `ind` - An individual.
        `kb` - A fuzzy KB.

    - #### computeAtomicConcepts

          public java.util.HashSet<Concept> computeAtomicConcepts()

      Description copied from class: `Concept`
      Gets a set of the atomic concepts that compose the current concept.
      Returns:
        A HashSet of instances of the class Concept.

    - #### getRoles

          public java.util.HashSet<java.lang.String> getRoles()

      Description copied from class: `Concept`
      Gets a set of the roles that compose the current concept.
      Returns:
        A HashSet of Strings representing the roles.

    - #### replace

          public Concept replace(Concept a,
                                 Concept c)
                          throws FuzzyOntologyException

      Description copied from class: `Concept`
      Gets a new concept by replacing an atomic concept a with a complex concept c.
      Overrides:
        `replace` in class `Concept`
      Parameters:
        `a` - Atomic concept.
        `c` - Complex concept.
      Returns:
        Complement of the concept.
      Throws:
        `FuzzyOntologyException` - Parsing error.